#include<vector>
#include<iostream>
#include "simplex.hpp"

int main(int argc, char* argv[]) {

  std::vector<double> ud(10,1.),vd(10,2.);
  std::vector<float > uf(10,1.),vf(10,2.);
  std::vector<Complex> uc(10,Complex(1.,0.)),vc(10,Complex(0.,1.));
  std::cout << "dotProd double (expected 20) " << dotProd(ud,vd) << std::endl;
  std::cout << "dotProd float (expected 20) " << dotProd(uf,vf) << std::endl;
  std::cout << "dotProd complex (expected -10i) " << dotProd(uc,vc) << std::endl;

  Point OR = Point();
  Point UX = Point();
  Point UY = Point();
  Point UZ = Point();
  for (int i=0;i<3;i++) OR[i] = 0.;
  UX[0] = 1.; UX[1] = 0.; UX[2] = 0.;
  UY[0] = 0.; UY[1] = 1.; UY[2] = 0.;
  UZ[0] = 0.; UZ[1] = 0.; UZ[2] = 1.;

  std::array<Point,1> pts0; pts0[0] = OR;
  Simplex<0> s0(pts0);
  std::cout << "Simplex 0 measure (0 expected) " << s0.measure() << std::endl;

  std::array<Point,2> pts1; pts1[0] = OR; pts1[1] = UX;
  Simplex<1> s1(pts1);
  std::cout << "Simplex 1 measure (1 expected) " << s1.measure() << std::endl;

  std::array<Point,3> pts2; pts2[0] = OR; pts2[1] = UX; pts2[2] = UY;
  Simplex<2> s2(pts2);
  std::cout << "Simplex 2 measure (1/2 expected) " << s2.measure() << std::endl;

  std::array<Point,4> pts3; pts3[0] = OR; pts3[1] = UX; pts3[2] = UY; pts3[3] = UZ;
  Simplex<3> s3(pts3);
  std::cout << "Simplex 3 measure (1/6 expected) " << s3.measure() << std::endl;

  return 0;
}


